## Index

### Classes

- BareFile
- BareTree
- BaseFile
- BaseTree
- FileSystem
- PrivateFile
- default
- default
- default
- default

### Interfaces

- AppPath
- BaseLink
- BaseLinks
- ConsumerEventMap
- File
- HardLink
- HardLinks
- Links
- ProducerEventMap
- Puttable
- SimpleLink
- SimpleLinks
- SoftLink
- Tree
- UnixTree

### Type aliases

- AppBase
- AppInfo
- BareNameFilter
- Channel
- ChannelData
- ChannelOptions
- ConstructorParams
- ConstructorParams
- ConstructorParams
- DecryptedNode
- Endpoints
- EventListener
- FileSystemOptions
- FileSystemPermissions
- IPFS
- Implementation
- Implementation
- Implementation
- Implementation
- InitOptions
- Link
- Member
- Metadata
- MutationOptions
- NewFileSystemOptions
- Node
- PermissionedAppBase
- Permissions
- PlatformPermissions
- PrivateAddResult
- PrivateFileInfo
- PrivateLink
- PrivateLinks
- PrivateName
- PrivateNode
- PrivateSkeleton
- PrivateSkeletonInfo
- PrivateTreeInfo
- PublishHook
- PuttableUnixTree
- RawPermission
- RawPermissions
- Revision
- SemVer
- ShareDetails
- SharedBy
- State
- UnixFileMode
- UnixMeta
- UpdateCallback
- UserMessages

## Type aliases

### AppBase

AppBase: { kind: "appState" }

- Defined in auth/state/app.ts:44

#### Type declaration

- ##### kind: "appState"

### AppInfo

AppInfo: { creator: string; name: string }

- Defined in ucan/permissions.ts:13

#### Type declaration

- ##### creator: string

- ##### name: string

### BareNameFilter

BareNameFilter: Opaque<"BareNameFilter", string>

- Defined in fs/protocol/private/namefilter.ts:19

### Channel

Channel: { close: any; send: any }

- Defined in auth/channel.ts:7

#### Type declaration

- ##### close:function

  - close(): void
  - - Defined in auth/channel.ts:9

    #### Returns void

- ##### send:function

  - send(data: ChannelData): void
  - - Defined in auth/channel.ts:8

    #### Parameters

    - ##### data: ChannelData

    #### Returns void

### ChannelData

ChannelData: string | ArrayBufferLike | Blob | ArrayBufferView

- Defined in auth/channel.ts:17

### ChannelOptions

ChannelOptions: { username: string; handleMessage: any }

- Defined in auth/channel.ts:12

#### Type declaration

- ##### username: string

- ##### handleMessage:function

  - handleMessage(event: MessageEvent<any>): void
  - - Defined in auth/channel.ts:14

    #### Parameters

    - ##### event: MessageEvent<any>

    #### Returns void

### ConstructorParams

ConstructorParams: { localOnly?: boolean; permissions?: Permissions; root: <internal>.default }

- Defined in fs/filesystem.ts:50

#### Type declaration

- ##### Optional localOnly?: boolean

- ##### Optional permissions?: Permissions

- ##### root: <internal>.default

### ConstructorParams

ConstructorParams: { header: PrivateTreeInfo; key: string; mmpt: <internal>.default }

- Defined in fs/v1/PrivateTree.ts:28

#### Type declaration

- ##### header: PrivateTreeInfo

- ##### key: string

- ##### mmpt: <internal>.default

### ConstructorParams

ConstructorParams: { content: FileContent; header: PrivateFileInfo; key: string; mmpt: <internal>.default }

- Defined in fs/v1/PrivateFile.ts:18

#### Type declaration

- ##### content: FileContent

- ##### header: PrivateFileInfo

- ##### key: string

- ##### mmpt: <internal>.default

### DecryptedNode

DecryptedNode: PrivateFileInfo | PrivateTreeInfo

- Defined in fs/protocol/private/types.ts:9

### Endpoints

Endpoints: { api: string; apiUrl: string | null; apiVersion: string; lobby: string; user: string }

- Defined in setup/internal.ts:3

#### Type declaration

- ##### api: string

- ##### apiUrl: string | null

- ##### apiVersion: string

- ##### lobby: string

- ##### user: string

### EventListener

EventListener<E>: (event: E) => void

- Defined in common/event-emitter.ts:1

#### Type parameters

- #### E

#### Type declaration

- - (event: E): void

  - #### Parameters

    - ##### event: E

    #### Returns void

### FileSystemOptions

FileSystemOptions: { localOnly?: boolean; permissions?: Permissions }

- Defined in fs/filesystem.ts:56

#### Type declaration

- ##### Optional localOnly?: boolean

- ##### Optional permissions?: Permissions

### FileSystemPermissions

FileSystemPermissions: { private?: DistinctivePath[]; public?: DistinctivePath[] }

- Defined in ucan/permissions.ts:18

#### Type declaration

- ##### Optional private?: DistinctivePath[]

- ##### Optional public?: DistinctivePath[]

### IPFS

IPFS: IPFSCore & { libp2p: libp2p }

- Defined in ipfs/node.ts:50

### Implementation

Implementation: { checkCapability: any; createChannel: any; delegateAccount: any; init: any; isUsernameAvailable: any; isUsernameValid: any; linkDevice: any; register: any }

- Defined in auth/implementation/types.ts:6

#### Type declaration

- ##### checkCapability:function

  - checkCapability(username: string): Promise<boolean>
  - - Defined in auth/implementation/types.ts:12

    #### Parameters

    - ##### username: string

    #### Returns Promise<boolean>

- ##### createChannel:function

  - createChannel(options: ChannelOptions): Promise<Channel>
  - - Defined in auth/implementation/types.ts:11

    #### Parameters

    - ##### options: ChannelOptions

    #### Returns Promise<Channel>

- ##### delegateAccount:function

  - delegateAccount(username: string, audience: string): Promise<Record<string, unknown>>
  - - Defined in auth/implementation/types.ts:13

    #### Parameters

    - ##### username: string

    - ##### audience: string

    #### Returns Promise<Record<string, unknown>>

- ##### init:function

  - init(options: InitOptions): Promise<null | <internal>.State>
  - - Defined in auth/implementation/types.ts:7

    #### Parameters

    - ##### options: InitOptions

    #### Returns Promise<null | <internal>.State>

- ##### isUsernameAvailable:function

  - isUsernameAvailable(username: string): Promise<boolean>
  - - Defined in auth/implementation/types.ts:10

    #### Parameters

    - ##### username: string

    #### Returns Promise<boolean>

- ##### isUsernameValid:function

  - isUsernameValid(username: string): Promise<boolean>
  - - Defined in auth/implementation/types.ts:9

    #### Parameters

    - ##### username: string

    #### Returns Promise<boolean>

- ##### linkDevice:function

  - linkDevice(data: Record<string, unknown>): Promise<void>
  - - Defined in auth/implementation/types.ts:14

    #### Parameters

    - ##### data: Record<string, unknown>

    #### Returns Promise<void>

- ##### register:function

  - register(options: { email?: string; username: string }): Promise<{ success: boolean }>
  - - Defined in auth/implementation/types.ts:8

    #### Parameters

    - ##### options: { email?: string; username: string }

      - ##### Optional email?: string

      - ##### username: string

    #### Returns Promise<{ success: boolean }>

### Implementation

Implementation: { ed25519: { verify: any }; keystore: { clear: any; decrypt: any; exportSymmKey: any; getAlg: any; importSymmKey: any; keyExists: any; publicExchangeKey: any; publicWriteKey: any; sign: any }; rsa: { verify: any } }

- Defined in crypto/implementation/types.ts:1

#### Type declaration

- ##### ed25519: { verify: any }

  - ##### verify:function

    - verify(message: Uint8Array, signature: Uint8Array, publicKey: Uint8Array): Promise<boolean>
    - - Defined in crypto/implementation/types.ts:6

      #### Parameters

      - ##### message: Uint8Array

      - ##### signature: Uint8Array

      - ##### publicKey: Uint8Array

      #### Returns Promise<boolean>

- ##### keystore: { clear: any; decrypt: any; exportSymmKey: any; getAlg: any; importSymmKey: any; keyExists: any; publicExchangeKey: any; publicWriteKey: any; sign: any }

  - ##### clear:function

    - clear(): Promise<void>
    - - Defined in crypto/implementation/types.ts:17

      #### Returns Promise<void>

  - ##### decrypt:function

    - decrypt(encrypted: string): Promise<string>
    - - Defined in crypto/implementation/types.ts:11

      #### Parameters

      - ##### encrypted: string

      #### Returns Promise<string>

  - ##### exportSymmKey:function

    - exportSymmKey(name: string): Promise<string>
    - - Defined in crypto/implementation/types.ts:14

      #### Parameters

      - ##### name: string

      #### Returns Promise<string>

  - ##### getAlg:function

    - getAlg(): Promise<string>
    - - Defined in crypto/implementation/types.ts:16

      #### Returns Promise<string>

  - ##### importSymmKey:function

    - importSymmKey(key: string, name: string): Promise<void>
    - - Defined in crypto/implementation/types.ts:13

      #### Parameters

      - ##### key: string

      - ##### name: string

      #### Returns Promise<void>

  - ##### keyExists:function

    - keyExists(keyName: string): Promise<boolean>
    - - Defined in crypto/implementation/types.ts:15

      #### Parameters

      - ##### keyName: string

      #### Returns Promise<boolean>

  - ##### publicExchangeKey:function

    - publicExchangeKey(): Promise<string>
    - - Defined in crypto/implementation/types.ts:9

      #### Returns Promise<string>

  - ##### publicWriteKey:function

    - publicWriteKey(): Promise<string>
    - - Defined in crypto/implementation/types.ts:10

      #### Returns Promise<string>

  - ##### sign:function

    - sign(message: string, charSize: number): Promise<string>
    - - Defined in crypto/implementation/types.ts:12

      #### Parameters

      - ##### message: string

      - ##### charSize: number

      #### Returns Promise<string>

- ##### rsa: { verify: any }

  - ##### verify:function

    - verify(message: Uint8Array, signature: Uint8Array, publicKey: Uint8Array): Promise<boolean>
    - - Defined in crypto/implementation/types.ts:3

      #### Parameters

      - ##### message: Uint8Array

      - ##### signature: Uint8Array

      - ##### publicKey: Uint8Array

      #### Returns Promise<boolean>

### Implementation

Implementation: { lookupDnsLink: any; lookupTxtRecord: any }

- Defined in dns/implementation/types.ts:1

#### Type declaration

- ##### lookupDnsLink:function

  - lookupDnsLink(domain: string): Promise<null | string>
  - - Defined in dns/implementation/types.ts:3

    #### Parameters

    - ##### domain: string

    #### Returns Promise<null | string>

- ##### lookupTxtRecord:function

  - lookupTxtRecord(domain: string): Promise<null | string>
  - - Defined in dns/implementation/types.ts:2

    #### Parameters

    - ##### domain: string

    #### Returns Promise<null | string>

### Implementation

Implementation: { clear: any; getItem: any; removeItem: any; setItem: any }

- Defined in storage/implementation/types.ts:1

#### Type declaration

- ##### clear:function

  - clear(): Promise<void>
  - - Defined in storage/implementation/types.ts:5

    #### Returns Promise<void>

- ##### getItem:function

  - getItem<T>(key: string): Promise<null | T>
  - - Defined in storage/implementation/types.ts:2

    #### Type parameters

    - #### T

    #### Parameters

    - ##### key: string

    #### Returns Promise<null | T>

- ##### removeItem:function

  - removeItem(key: string): Promise<void>
  - - Defined in storage/implementation/types.ts:4

    #### Parameters

    - ##### key: string

    #### Returns Promise<void>

- ##### setItem:function

  - setItem<T>(key: string, val: T): Promise<T>
  - - Defined in storage/implementation/types.ts:3

    #### Type parameters

    - #### T

    #### Parameters

    - ##### key: string

    - ##### val: T

    #### Returns Promise<T>

### InitOptions

InitOptions: AppInitOptions | PermissionedAppInitOptions

- Defined in init/types.ts:17

### Link

Link: HardLink | SoftLink | BaseLink

- Defined in fs/types.ts:41

### Member

Member: { cid: CID; name: string }

- Defined in fs/protocol/private/mmpt.ts:17

#### Type declaration

- ##### cid: CID

- ##### name: string

### Metadata

Metadata: { isFile: boolean; unixMeta: UnixMeta; version: SemVer }

- Defined in fs/metadata.ts:22

#### Type declaration

- ##### isFile: boolean

- ##### unixMeta: UnixMeta

- ##### version: SemVer

### MutationOptions

MutationOptions: { publish?: boolean }

- Defined in fs/filesystem.ts:65

#### Type declaration

- ##### Optional publish?: boolean

### NewFileSystemOptions

NewFileSystemOptions: FileSystemOptions & { rootKey?: string }

- Defined in fs/filesystem.ts:61

### Node

Node: { constructor: { fromInfo: any }; header: { bareNameFilter: BareNameFilter; metadata: Metadata; revision: number }; key: string; mmpt: <internal>.default }

- Defined in fs/v1/PrivateHistory.ts:9

#### Type declaration

- ##### constructor: { fromInfo: any }

  - ##### fromInfo:function

    - fromInfo(mmpt: <internal>.default, key: string, info: DecryptedNode): Node
    - - Defined in fs/v1/PrivateHistory.ts:11

      #### Parameters

      - ##### mmpt: <internal>.default

      - ##### key: string

      - ##### info: DecryptedNode

      #### Returns Node

- ##### header: { bareNameFilter: BareNameFilter; metadata: Metadata; revision: number }

  - ##### bareNameFilter: BareNameFilter

  - ##### metadata: Metadata

  - ##### revision: number

- ##### key: string

- ##### mmpt: <internal>.default

### PermissionedAppBase

PermissionedAppBase: { kind: "permissionedAppState" }

- Defined in auth/state/permissionedApp.ts:94

#### Type declaration

- ##### kind: "permissionedAppState"

### Permissions

Permissions: { app?: AppInfo; fs?: FileSystemPermissions; platform?: PlatformPermissions; raw?: RawPermissions; sharing?: boolean }

- Defined in ucan/permissions.ts:5

#### Type declaration

- ##### Optional app?: AppInfo

- ##### Optional fs?: FileSystemPermissions

- ##### Optional platform?: PlatformPermissions

- ##### Optional raw?: RawPermissions

- ##### Optional sharing?: boolean

### PlatformPermissions

PlatformPermissions: { apps: "*" | string[] }

- Defined in ucan/permissions.ts:23

#### Type declaration

- ##### apps: "*" | string[]

### PrivateAddResult

PrivateAddResult: AddResult & { key: string; name: PrivateName; skeleton: PrivateSkeleton }

- Defined in fs/protocol/private/types.ts:42

### PrivateFileInfo

PrivateFileInfo: { bareNameFilter: BareNameFilter; content: CID | string; key: string; metadata: Metadata; revision: number }

- Defined in fs/protocol/private/types.ts:11

#### Type declaration

- ##### bareNameFilter: BareNameFilter

- ##### content: CID | string

- ##### key: string

- ##### metadata: Metadata

- ##### revision: number

### PrivateLink

PrivateLink: BaseLink & { key: string; pointer: PrivateName }

- Defined in fs/protocol/private/types.ts:19

### PrivateLinks

PrivateLinks: {}

- Defined in fs/protocol/private/types.ts:24

#### Type declaration

- ##### [name: string]: PrivateLink | SoftLink

### PrivateName

PrivateName: Opaque<"PrivateName", string>

- Defined in fs/protocol/private/namefilter.ts:16

### PrivateNode

PrivateNode: <internal>.default | PrivateFile

- Defined in fs/root/tree.ts:33

### PrivateSkeleton

PrivateSkeleton: {}

- Defined in fs/protocol/private/types.ts:34

#### Type declaration

- ##### [name: string]: PrivateSkeletonInfo | SoftLink

### PrivateSkeletonInfo

PrivateSkeletonInfo: { cid: CID | string; key: string; subSkeleton: PrivateSkeleton }

- Defined in fs/protocol/private/types.ts:36

#### Type declaration

- ##### cid: CID | string

- ##### key: string

- ##### subSkeleton: PrivateSkeleton

### PrivateTreeInfo

PrivateTreeInfo: { bareNameFilter: BareNameFilter; links: PrivateLinks; metadata: Metadata; revision: number; skeleton: PrivateSkeleton }

- Defined in fs/protocol/private/types.ts:26

#### Type declaration

- ##### bareNameFilter: BareNameFilter

- ##### links: PrivateLinks

- ##### metadata: Metadata

- ##### revision: number

- ##### skeleton: PrivateSkeleton

### PublishHook

PublishHook: (result: CID, proof: string) => unknown

- Defined in fs/types.ts:61

#### Type declaration

- - (result: CID, proof: string): unknown

  - #### Parameters

    - ##### result: CID

    - ##### proof: string

    #### Returns unknown

### PuttableUnixTree

PuttableUnixTree: UnixTree & Puttable

- Defined in fs/types.ts:64

### RawPermission

RawPermission: { exp: number; ptc: Potency; rsc: Resource }

- Defined in ucan/permissions.ts:29

#### Type declaration

- ##### exp: number

- ##### ptc: Potency

- ##### rsc: Resource

### RawPermissions

RawPermissions: RawPermission[]

- Defined in ucan/permissions.ts:27

### Revision

Revision: { cid: CID | string; name: PrivateName; number: number }

- Defined in fs/protocol/private/types.ts:48

#### Type declaration

- ##### cid: CID | string

- ##### name: PrivateName

- ##### number: number

### SemVer

SemVer: { major: number; minor: number; patch: number }

- Defined in fs/versions.ts:2

#### Type declaration

- ##### major: number

- ##### minor: number

- ##### patch: number

### ShareDetails

ShareDetails: { shareId: string; sharedBy: SharedBy }

- Defined in fs/types.ts:63

#### Type declaration

- ##### shareId: string

- ##### sharedBy: SharedBy

### SharedBy

SharedBy: { rootDid: string; username: string }

- Defined in fs/types.ts:62

#### Type declaration

- ##### rootDid: string

- ##### username: string

### State

State: AppState | State

- Defined in auth/state.ts:14

### UnixFileMode

UnixFileMode: number

- Defined in fs/metadata.ts:4

### UnixMeta

UnixMeta: { _type: string; ctime: number; mode: UnixFileMode; mtime: number }

- Defined in fs/metadata.ts:15

#### Type declaration

- ##### _type: string

- ##### ctime: number

- ##### mode: UnixFileMode

- ##### mtime: number

### UpdateCallback

UpdateCallback: () => Promise<unknown>

- Defined in fs/types.ts:60

#### Type declaration

- - (): Promise<unknown>

  - #### Returns Promise<unknown>

### UserMessages

UserMessages: { versionMismatch: { newer: any; older: any } }

- Defined in setup/internal.ts:11

#### Type declaration

- ##### versionMismatch: { newer: any; older: any }

  - ##### newer:function

    - newer(version: string): Promise<void>
    - - Defined in setup/internal.ts:13

      #### Parameters

      - ##### version: string

      #### Returns Promise<void>

  - ##### older:function

    - older(version: string): Promise<void>
    - - Defined in setup/internal.ts:14

      #### Parameters

      - ##### version: string

      #### Returns Promise<void>

Generated using TypeDoc